# -*- coding: utf-8 -*-
#
# File: googlecoop.py
#
# Copyright (c) 2007 by []
# Generator: ArchGenXML Version 1.6.0-beta-svn
#            http://plone.org/products/archgenxml
#
# GNU General Public License (GPL)
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
# 02110-1301, USA.
#

__author__ = """Christian Ledermann <unknown>"""
__docformat__ = 'plaintext'

from AccessControl import ClassSecurityInfo
from Products.Archetypes.atapi import *
from Products.googlecoop.config import *


from Products.CMFCore.utils import UniqueObject

    
##code-section module-header #fill in your manual code here
import md5
##/code-section module-header

schema = Schema((

    StringField(
        name='identifier',
        default="009744842749537478185:hwbuiarvsbo",
        widget=StringWidget(
            description="Your Custom Search Engine's unique identifier",
            label="Identifier",
            label_msgid='googlecoop_label_identifier',
            description_msgid='googlecoop_help_identifier',
            i18n_domain='googlecoop',
        ),
        required=True,
        read_permission="View",
        write_permission="Manage Portal"
    ),

    StringField(
        name='adsposition',
        widget=SelectionWidget(
            label="Show ads on results pages",
            description="Specify where in the results you want advertising to be placed.",
            label_msgid='googlecoop_label_adsposition',
            description_msgid='googlecoop_help_adsposition',
            i18n_domain='googlecoop',
        ),
        read_permission="View",
        vocabulary='getAdsVocabulary',
        default='FORID:9',
        required=True,
        write_permission="Manage Portal"
    ),

    StringField(
        name='domain',
        default="www.google.com",
        widget=StringWidget(
            label="Google Domain",
            description="You can choose a different Google domain than google.com (such as google.ru or google.es). This makes your search results favor results from that country.",
            label_msgid='googlecoop_label_domain',
            description_msgid='googlecoop_help_domain',
            i18n_domain='googlecoop',
        ),
        required=True,
        read_permission="View",
        write_permission="Manage Portal"
    ),

),
)

##code-section after-local-schema #fill in your manual code here
##/code-section after-local-schema

googlecoop_schema = BaseSchema.copy() + \
    schema.copy()

##code-section after-schema #fill in your manual code here
##/code-section after-schema

class googlecoop(UniqueObject, BaseContent):
    """
    """
    security = ClassSecurityInfo()
    __implements__ = (getattr(UniqueObject,'__implements__',()),) + (getattr(BaseContent,'__implements__',()),)

    # This name appears in the 'add' box
    archetype_name = 'Google Coop'

    meta_type = 'googlecoop'
    portal_type = 'googlecoop'
    allowed_content_types = []
    filter_content_types = 0
    global_allow = 0
    #content_icon = 'googlecoop.gif'
    immediate_view = 'base_view'
    default_view = 'base_view'
    suppl_views = ()
    typeDescription = "Google Coop"
    typeDescMsgId = 'description_edit_googlecoop'
    toolicon = 'google-coop.png'


    actions =  (


       {'action': "string:${object_url}/getAllRemoteURLs",
        'category': "object",
        'id': 'getRemoteUrls',
        'name': 'Get all URLs',
        'permissions': ("View",),
        'condition': 'python:1'
       },


       {'action': "string:${object_url}/googlecoop",
        'category': "object",
        'id': 'gcSearchForm',
        'name': 'Search',
        'permissions': ("View",),
        'condition': 'python:1'
       },


    )

    _at_rename_after_creation = True

    schema = googlecoop_schema

    ##code-section class-header #fill in your manual code here
    def getAdsVocabulary(self):
    	return ADPLACEMENT.items()
    ##/code-section class-header


    # tool-constructors have no id argument, the id is fixed
    def __init__(self, id=None):
        BaseContent.__init__(self,'portal_googlecoop')
        self.setTitle('Google Coop')
        
        ##code-section constructor-footer #fill in your manual code here
        ##/code-section constructor-footer


    # tool should not appear in portal_catalog
    def at_post_edit_script(self):
        self.unindexObject()
        
        ##code-section post-edit-method-footer #fill in your manual code here
        ##/code-section post-edit-method-footer


    # Methods

    security.declarePublic('getGoCoopJS')
    def getGoCoopJS(self):
        """
        Return JS code to display your search results
        """
	JSCode ='''
  	var googleSearchIframeName = "results_%s";
  	var googleSearchFormName = "searchbox_%s";
  	var googleSearchFrameWidth = 600;
  	var googleSearchFrameborder = 0;
  	var googleSearchDomain = "%s";
  	var googleSearchPath = "/cse";
	'''  % (self.identifier, self.identifier, self.domain)

	return JSCode

    security.declarePublic('getAllRemoteURLs')
    def getAllRemoteURLs(self):
        """
        Returns all remote_urls from the portal catalog
        """
        URLs = self.portal_catalog.uniqueValuesFor('getRemoteUrl')
        AllURLs = '\n'.join(URLs)
        return AllURLs

    security.declarePublic('uniqueURLID')
    def uniqueURLID(self,URL=None):
        """
        Return an uniqe ID for a given URL
        """
        try:
            sig = md5.new(URL)
        except:
            sig = md5.new(self.identifier)
        urlId = "_cse_" + sig.hexdigest()
        return urlId

    security.declarePublic('getCseCrefJS')
    def getCseCrefJS(self):
        """
        Return JavaScript for a Linked Custom Search Engine
        """
        JSCode ='''
          var googleSearchIframeName = "results_cref";
          var googleSearchFormName = "searchbox_cref";
          var googleSearchFrameWidth = 600;
          var googleSearchFrameborder = 0;
          var googleSearchDomain = "%s";
          var googleSearchPath = "/cse";
        '''  % (self.domain)

    # Manually created methods

    def getAdsVocabulary(self):
    	return ADPLACEMENT.items()
    ##/code-section class-header


registerType(googlecoop, PROJECTNAME)
# end of class googlecoop

##code-section module-footer #fill in your manual code here
##/code-section module-footer



